macro level {from to N} {
  set colors [list red purple darkblue yellow darkgreen brown black] 
  set lvl $from
  set restore [:set Output,Level]
  set step [expr {($to-$from)/($N-1)}]
  #set initial output level
  :set Output,Level $lvl
  set ID [:measure]
  set k [expr {[:query $ID OutLvl]/$lvl}]
  set lvl [expr {$k*$lvl}]
  set step [expr {$k*$step}]
  for {set i 0} {$i < $N} {incr i} {
    :set Output,Level $lvl
    :measure
    set ID [:paste]
    # control the output level
    # allow 10% difference
    if {[expr {([:query $ID OutLvl]-$lvl)/$lvl}] > 0.1} {
      :message {Maximum output level exceed. Aborting.}
      break
    }
    :modify $ID Name [format "%.1f V RMS" [:query $ID OutLvl]] Color [lindex $colors [expr {$i % [llength $colors]}]]
    set lvl [expr {$lvl+$step}]
  }
  :set Output,Level $restore
}
